package 
{
	import adobe.utils.CustomActions;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	
	
	
	public class TheWorld extends Sprite
	{
		public const nBall:int = 30;
		public const yA:Number = 200;
		public const yB:Number = 400;
		public const yC:Number = 600;
		public var ball1Array:Array;
		public var ball2Array:Array;
		public var ball3Array:Array;
		public var y1Array:Array;
		public var y2Array:Array;
		public var y3Array:Array;
		
		
		public var ball01:BallMouse;
		
		public var isInverse:Boolean = false;
		
		public var isDrag:Boolean = false;
		
		
		//control
		public var allControl:AllControl;
		public var isPlay:Boolean = true;
		
		
		
		public function TheWorld():void
		{
			//once
			//bg
			this.addChild(new BG());
			
			//line
			//1
			var line:Line = new Line();
			line.y = yA;
			this.addChild(line);
			//2
			line = new Line();
			line.y = yB;
			this.addChild(line);
			//3
			line = new Line();
			line.y = yC;
			this.addChild(line);
			
			
			//ball01
			ball01 = new BallMouse();
			ball01.x = 50;
			ball01.y = 200;
			this.addChild(ball01);
			ball01.addEventListener(MouseEvent.MOUSE_DOWN, downBall);
			this.addEventListener(MouseEvent.MOUSE_UP, myUp);
			
			
			
			
			//array
			ball1Array = new Array();
			ball2Array = new Array();
			ball3Array = new Array();
			y1Array = new Array();
			y2Array = new Array();
			y3Array = new Array();
			for (var i:int = 0; i < nBall; i++) {
				//1
				var ballMC:BallMC = new BallMC();
				ballMC.x = 50 + 950 / nBall * i;
				ballMC.y = yA;
				this.addChild(ballMC);
				
				ball1Array.push(ballMC);
				y1Array.push(0);
				
				
				//2
				ballMC = new BallMC();
				ballMC.x = 50 + 950 / nBall * i;
				ballMC.y = yB;
				this.addChild(ballMC);
				
				ball2Array.push(ballMC);
				y2Array.push(0);
				
				
				//3
				ballMC = new BallMC();
				ballMC.x = 50 + 950 / nBall * i;
				ballMC.y = yC;
				this.addChild(ballMC);
				
				ball3Array.push(ballMC);
				y3Array.push(0);
			}
			
			
			ball1Array[0].addEventListener(MouseEvent.MOUSE_DOWN, downBall);
			
			
			
			
			
			this.addEventListener(Event.ENTER_FRAME, myshow);
			
			
			//control
			allControl = new AllControl();
			allControl.x = 10;
			allControl.y = 720;
			this.addChild(allControl);
			
			allControl.btnStep.addEventListener(MouseEvent.CLICK, clickBtnStep);
			
		}
		
		
		private function myshow(e:Event):void {
			
			//isInverse
			isInverse = allControl.chIsInverse.selected;
			
			
			if(isPlay){	
				//slow
				ball1Array[0].y = 0.8 * ball1Array[0].y + 0.2 * ball01.y;
				
				
				//傳遞波動
				//1
				for (var i:int = 1; i < nBall; i++) {
					ball1Array[i].y = y1Array[i - 1]+yA;
				}
				//2
				ball2Array[nBall - 1].y = (isInverse?-1:1)*(ball1Array[0].y - yA) + yB;
				for (i = nBall-2; i >=0; i--) {
					ball2Array[i].y = y2Array[i + 1] + yB;
				}
				
				
				
				//更新 yArray
				for (var i:int = 0; i < nBall; i++) {
					y1Array[i] = ball1Array[i].y - yA;
					y2Array[i] = ball2Array[i].y - yB;
					
					y3Array[i] = y1Array[i] + y2Array[i];
				}
				
				//3 球
				for (i = 0; i < nBall; i++) {
					ball3Array[i].y = y3Array[i] + yC;
				}
				
				
				
				//ball01 歸位
				if (!isDrag) {
					//沒拖曳
					ball01.y = 0.8*ball01.y+0.2*yA;
				}
			}
		}
		
		
		
		
		private function downBall(e:MouseEvent):void {
			ball01.startDrag(false, new Rectangle(50, 0, 0, 768));
			isDrag = true;
		}
		private function myUp(e:MouseEvent):void {
			ball01.stopDrag();
			isDrag = false;
		}
		
		private function clickBtnStep(e:MouseEvent):void {
			isPlay = !isPlay;
		}
	}

}